/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is openCRX.
 *
 * The Initial Developer of the Original Code is
 * Josh Geenen <openrx@pirules.net>.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var oImport = {
  begin: function oImport_begin(aVCards, aAbName) {
    oLOGGER.VERBOSE_LOG(aVCards);
    oLOGGER.LOG("***Starting import to the address book named: " + aAbName +
                " at: " + (new Date()).toLocaleTimeString());
    var ab = new oAddressBook(oAbManager.getAbByName(aAbName));
    oOverlay.setStatusBarText("parsing vcards");
    
    // split up the response into individual vCards
    var vCards = aVCards ? aVCards.split("END:VCARD") : "";
    // clear the existing cards
    oOverlay.setStatusBarText("Deleting existing contacts");
    ab.deleteCards(ab.getAllCards());
    
    if (!vCards) {
      oLOGGER.LOG("***Did not find any contacts to import");
      oOverlay.setStatusBarText("Did not find any contacts at the given URL");
      return;
    }
    
    // add the new cards to the address book
    oOverlay.setStatusBarText("Adding new contacts");
    
    for (var i = 0; i < vCards.length; i++) {
      oOverlay.setStatusBarText("Adding new contacts: " + (i + 1) + " of " + vCards.length);
      try {
        // convert the vCard to a nsIAbCard (contact in Thunderbird)
        var contact = oContactConverter.vCardToContact(vCards[i], ab);

        // make sure the card is valid (may throw an exception if not)
        if (!oAbManager.getCardValue(contact, "openCrxId"))
          ab.deleteCards([contact]);
        else if (!oAbManager.getCardValue(contact, "DisplayName") &&
                !oAbManager.getCardValue(contact, "PrimaryEmail") &&
                !oAbManager.getCardValue(contact, "SecondEmail"))
          ab.deleteCards([contact]);
        //oAbManager.checkCard(contact);
        //ab.addCard(contact);
      }
      catch (e) { oLOGGER.LOG_WARNING("Caught invalid contact:\n" + e + "\nSource:\n" + vCards[i]); }
    }
    oLOGGER.LOG("***Finished import to the address book named: " + aAbName +
                " at: " + (new Date()).toLocaleTimeString());
    oOverlay.writeTimeToStatusBar();
  }
};
